# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, playerlib
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func    = es.import_addon('sam/functions')
monitor = es.import_addon('sam/core/monitor')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
temp = {'trigger':15,'current':0}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# CMD
	func.ServerCMD('sam_switcher_rounds', triggerCMD)

	# CFG
	lib = {'sam_switcher_rounds':{'value':temp['trigger'],'description':'Number of rounds to before switching teams.'}}
	monitor.cfg('switcher', lib)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# CMD
	func.unServerCMD('sam_switcher_rounds')

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def switch():
	if (1+temp['current']) > temp['trigger']:
		teams = es.import_addon('sam/core/pcontrol/manageteams')
		teams.swapTeams(False, None, None)
		temp['current'] = 0
	else:
		temp['current'] += 1
		num = temp['trigger']-temp['current']+1
		if num == 1: num = 'next'
		func.log('Swicthing teams in %s round/s.' % (num),'Switcher')

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def triggerCMD(args):
	if args:
		args = ' '.join(args)
		if args.isdigit(): temp['trigger'] = int(args)

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def round_end(ev): switch()

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def es_map_start(ev): temp['current'] = 0

# =============================================================================== #